#include <Arduino.h>
#include <Servo.h>
#include "IOpins.h"
#include "Constants.h"

bool flag0, flag1, f0 ,f1;
int pul, num, herace0, herace1;
int i = 0, j = 14, k = 140, c = 95;
bool LD = 0, LD1 = 0, RD = 0, RD1 = 0;
int LEFT = 22, LEFT1 = 24, RIGHT = 26, RIGHT1 = 28;

uint32_t data_mega;
uint32_t mls_timer;

Servo Servo0;
Servo Servo1;
Servo Servo2;
Servo Servo3;
Servo Servo4;
Servo Servo5;
Servo Servo6;

void setup()
{

  Servo0.attach(S0);
  Servo1.attach(S1);
  Servo2.attach(S2);


  Servo0.write(j);
  Servo1.write(k);
  Servo2.write(c);
  Servo3.write(0);
  Servo4.write(0);
  Servo5.write(0);
  Servo6.write(0);

  Serial.begin(9600);
  Serial.setTimeout(4);
}
void drive(uint32_t data_mega) {

  if (data_mega >= 256 && data_mega <= 511) {
    if (data_mega >= 166 + 256 && data_mega <= 511) { //назад
      num = map(data_mega,166 + 256, 511,55 ,255);
      analogWrite (LmotorA, 0);
      analogWrite (LmotorB, num);
      analogWrite (RmotorA, 0);
      analogWrite (RmotorB, num);
    }
    if (data_mega >= 256 && data_mega <= 89 + 256) { // вперед
      num = map(data_mega,256, 89 + 256,255 ,55);
      analogWrite(LmotorA, num);
      analogWrite (LmotorB, 0);
      analogWrite (RmotorA, num);
      analogWrite (RmotorB, 0);
    }
  }

  if (data_mega >= 512 && data_mega <= 767) {
    if (data_mega >= 512 && data_mega<= 89 + 512) { //влево
      num = map(data_mega, 512, 89 + 512,255 ,55);
      analogWrite (LmotorA, 0);
      analogWrite (LmotorB, num);
      analogWrite (RmotorA, num);
      analogWrite (RmotorB, 0);
    }
    if (data_mega >= 166 + 512 && data_mega <= 512 + 255) { //вправо
      num = map(data_mega,166 + 512, 512 + 255, 55, 255);
      analogWrite (LmotorA, num);
      analogWrite (LmotorB, 0);
      analogWrite (RmotorA, 0);
      analogWrite (RmotorB, num);
    }
  }
  if (data_mega >= 768 && data_mega <= 1023) {
    num = map(data_mega,768, 1023,5 ,175);
    Servo2.write(180 - num);
  }
  if (data_mega == 0) { //стоп
    Servo2.write(95);
    analogWrite (LmotorA, 0);
    analogWrite (LmotorB, 0);
    analogWrite (RmotorA, 0);
    analogWrite (RmotorB, 0);
  }
}
void krallen(uint32_t data_mega) {
  if(data_mega == 3 && f0 == 0){
    flag0 = !flag0;
    f0=1;
  }
  if(data_mega != 3 && f0 == 1){
    f0=0;
  }

  if(data_mega == 4 && f1 == 0){
    flag1 = !flag1;
    f1=1;
  }
  if(data_mega != 4 && f1 == 1){
    f1=0;
  }
  
  if (flag0 == 0) {
    if (data_mega >= 1024 && data_mega <= 1279) {
      herace0 = map(data_mega,1024, 1279,10 ,165);
      Servo0.write(herace0);
    }
  } else {
    Servo0.write(herace0);
  }
  if (flag1 == 0) {
    if (data_mega >= 1280 && data_mega <= 1535) {
      herace1 = map(data_mega,1280, 1535,58 ,140);
      Servo1.write(herace1);
    }
  } else {
    Servo1.write(herace1);
  }
}
void loop()
{
  if(millis() - mls_timer > 40){
    if (Serial.available()) data_mega = Serial.parseInt();
    Serial.println(data_mega);
  }

  drive(data_mega);
  krallen(data_mega);
}